/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
	"fmt"
)

// Messenger the model 'Messenger'
type Messenger string

// List of Messenger
const (
	MESSENGER_WHATS_APP Messenger = "WhatsApp"
	MESSENGER_TELEGRAM_BOT Messenger = "TelegramBot"
	MESSENGER_WEBCHAT Messenger = "Webchat"
	MESSENGER_VIBER_CHATBOTS Messenger = "ViberChatbots"
	MESSENGER_FACEBOOK_MESSENGER Messenger = "FacebookMessenger"
	MESSENGER_INSTAGRAM_MESSENGER Messenger = "InstagramMessenger"
	MESSENGER_SMS Messenger = "SMS"
	MESSENGER_GOOGLE_BM Messenger = "GoogleBM"
	MESSENGER_IN_APP Messenger = "InApp"
)

// All allowed values of Messenger enum
var AllowedMessengerEnumValues = []Messenger{
	"WhatsApp",
	"TelegramBot",
	"Webchat",
	"ViberChatbots",
	"FacebookMessenger",
	"InstagramMessenger",
	"SMS",
	"GoogleBM",
	"InApp",
}

func (v *Messenger) UnmarshalJSON(src []byte) error {
	var value string
	err := json.Unmarshal(src, &value)
	if err != nil {
		return err
	}
	enumTypeValue := Messenger(value)
	for _, existing := range AllowedMessengerEnumValues {
		if existing == enumTypeValue {
			*v = enumTypeValue
			return nil
		}
	}

	return fmt.Errorf("%+v is not a valid Messenger", value)
}

// NewMessengerFromValue returns a pointer to a valid Messenger
// for the value passed as argument, or an error if the value passed is not allowed by the enum
func NewMessengerFromValue(v string) (*Messenger, error) {
	ev := Messenger(v)
	if ev.IsValid() {
		return &ev, nil
	} else {
		return nil, fmt.Errorf("invalid value '%v' for Messenger: valid values are %v", v, AllowedMessengerEnumValues)
	}
}

// IsValid return true if the value is valid for the enum, false otherwise
func (v Messenger) IsValid() bool {
	for _, existing := range AllowedMessengerEnumValues {
		if existing == v {
			return true
		}
	}
	return false
}

// Ptr returns reference to Messenger value
func (v Messenger) Ptr() *Messenger {
	return &v
}

type NullableMessenger struct {
	value *Messenger
	isSet bool
}

func (v NullableMessenger) Get() *Messenger {
	return v.value
}

func (v *NullableMessenger) Set(val *Messenger) {
	v.value = val
	v.isSet = true
}

func (v NullableMessenger) IsSet() bool {
	return v.isSet
}

func (v *NullableMessenger) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessenger(val *Messenger) *NullableMessenger {
	return &NullableMessenger{value: val, isSet: true}
}

func (v NullableMessenger) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessenger) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}

